<script setup lang="ts">
import { useRoute, useRouter } from "vue-router";
import {
  type NestedWorkflowParameters,
  type TemporaryParams,
} from "@/types/WorkflowParameters.ts";
import { computed, onMounted, ref, watch } from "vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import type { ClowmInfo } from "@/types/ClowmInfo.ts";
import LastParameterizationsModal from "@/components/parameter-schema/LastParameterizationsModal.vue";
import UploadParameterFileModal from "@/components/parameter-schema/UploadParameterFileModal.vue";
import { Tooltip } from "bootstrap";
import {
  ParameterVisibility,
  type ParameterVisibilityMapping,
} from "@/client/types.gen.ts";
import { useUserStore } from "@/stores/users.ts";

const props = defineProps<{
  parameterGroups: object;
  parameterVisibility: ParameterVisibilityMapping;
  clowmInfo?: ClowmInfo;
  launchable?: boolean;
  formId?: string;
  workflowId?: string;
}>();

const emit = defineEmits<{
  (e: "change-view-mode", viewMode: ParameterVisibility): void;
  (e: "load-parameters", tempParams: TemporaryParams): void;
}>();

const route = useRoute();
const router = useRouter();
const userRepository = useUserStore();

const viewMode = ref<ParameterVisibility>(ParameterVisibility.SIMPLE);

watch(
  () => route.query?.viewMode,
  (newVal, oldVal) => {
    if (newVal != oldVal) {
      /* eslint-disable @typescript-eslint/ban-ts-comment */
      // @ts-ignore
      setViewMode(newVal);
    }
  },
);

type ParameterGroup = {
  group: string;
  title: string;
  icon?: string;
};

// Create a list with the names of all parameter groups
/* eslint-disable @typescript-eslint/ban-ts-comment */
// @ts-ignore
const navParameterGroups = computed<ParameterGroup[]>(() => {
  return Object.keys(props.parameterGroups)
    .map((group) => {
      return {
        group: group,
        /* eslint-disable @typescript-eslint/ban-ts-comment */
        // @ts-ignore
        title: props.parameterGroups[group]["title"],
        /* eslint-disable @typescript-eslint/ban-ts-comment */
        // @ts-ignore
        icon: props.parameterGroups[group]["fa_icon"],
      };
    })
    .filter(
      (group) =>
        /* eslint-disable @typescript-eslint/ban-ts-comment */
        // @ts-ignore
        Object.keys(props.parameterGroups[group.group]["properties"]).filter(
          (key: string) =>
            (props.parameterVisibility[key] ?? ParameterVisibility.SIMPLE) <=
            viewMode.value,
        ).length > 0,
    );
});

function scroll(selectedAnchor: string) {
  document.querySelector(selectedAnchor)?.scrollIntoView({
    behavior: "smooth",
  });
}

function setViewMode(viewModeString?: string | null) {
  switch (viewModeString) {
    case "simple": {
      viewMode.value = ParameterVisibility.SIMPLE;
      break;
    }
    case "advanced": {
      viewMode.value = ParameterVisibility.ADVANCED;
      break;
    }
    case "expert": {
      viewMode.value = ParameterVisibility.EXPERT;
      break;
    }
    case "invisible": {
      viewMode.value = ParameterVisibility.INVISIBLE;
      break;
    }
    default: {
      viewMode.value = ParameterVisibility.SIMPLE;
    }
  }
  emit("change-view-mode", viewMode.value);
}

onMounted(() => {
  /* eslint-disable @typescript-eslint/ban-ts-comment */
  // @ts-ignore
  setViewMode(route.query?.["viewMode"]);
  if (props.launchable && props.clowmInfo?.exampleParameters) {
    Tooltip.getOrCreateInstance("#TryItOutButton");
  }
});
</script>

<template>
  <upload-parameter-file-modal
    v-if="props.launchable"
    modal-id="parameterUploadModal"
    @parameters-uploaded="
      (params: NestedWorkflowParameters) =>
        emit('load-parameters', {
          params: params,
          metaParams: {},
        })
    "
  />
  <last-parameterizations-modal
    v-if="props.workflowId != undefined && props.launchable"
    modal-id="last-parameterization-modal"
    :workflow-id="props.workflowId"
    @parameters-selected="(params) => emit('load-parameters', params)"
  />
  <div
    class="col-3 sticky-top border shadow-sm rounded-1 px-0 overflow-y-auto"
    style="top: 70px !important; max-height: calc(100vh - 100px)"
  >
    <h5 class="mx-3 mt-2">Parameter View</h5>
    <div class="mx-2">
      <div
        class="btn-group my-1 w-100"
        role="group"
        aria-label="Basic radio toggle button group"
      >
        <input
          id="view-mode-simple"
          type="radio"
          class="btn-check"
          name="view-mode"
          autocomplete="off"
          :checked="viewMode === ParameterVisibility.SIMPLE"
          @click="
            router.replace({
              query: { ...route.query, viewMode: 'simple' },
              hash: route.hash,
            })
          "
        />
        <label class="btn btn-outline-primary" for="view-mode-simple"
          >Simple</label
        >
        <input
          id="view-mode-advanced"
          type="radio"
          class="btn-check"
          name="view-mode"
          autocomplete="off"
          :checked="viewMode === ParameterVisibility.ADVANCED"
          @click="
            router.replace({
              query: { ...route.query, viewMode: 'advanced' },
              hash: route.hash,
            })
          "
        />
        <label class="btn btn-outline-primary" for="view-mode-advanced"
          >Advanced</label
        >
        <input
          id="view-mode-expert"
          type="radio"
          class="btn-check"
          name="view-mode"
          autocomplete="off"
          :checked="viewMode === ParameterVisibility.EXPERT"
          @click="
            router.replace({
              query: { ...route.query, viewMode: 'expert' },
              hash: route.hash,
            })
          "
        />
        <label class="btn btn-outline-primary" for="view-mode-expert"
          >Expert</label
        >
        <template v-if="userRepository.admin">
          <input
            id="view-mode-invisible"
            type="radio"
            class="btn-check"
            name="view-mode"
            autocomplete="off"
            :checked="viewMode === ParameterVisibility.INVISIBLE"
            @click="
              router.replace({
                query: { ...route.query, viewMode: 'invisible' },
                hash: route.hash,
              })
            "
          />
          <label class="btn btn-outline-primary" for="view-mode-invisible">
            Invisible
          </label>
        </template>
      </div>
    </div>
    <nav class="h-100">
      <nav class="nav">
        <ul class="ps-0">
          <li
            v-for="group in navParameterGroups"
            :key="group.group"
            class="nav-link"
          >
            <router-link
              :to="{ hash: '#' + group.group, query: route.query }"
              replace
              @click="scroll('#' + group.group)"
            >
              <font-awesome-icon
                v-if="group.icon"
                :icon="group.icon"
                class="me-2"
              />
              {{ group.title }}
            </router-link>
          </li>
          <li v-if="props.launchable" class="nav-link">
            <router-link
              :to="{ hash: '#pipelineGeneralOptions', query: route.query }"
              replace
              @click="scroll('#pipelineGeneralOptions')"
            >
              <font-awesome-icon icon="fa-solid fa-gear" class="me-2" />
              General Pipeline Options
            </router-link>
          </li>
        </ul>
      </nav>
    </nav>
    <div v-if="props.launchable" class="d-grid gap-2 mb-2 px-2">
      <button
        v-if="props.clowmInfo?.exampleParameters"
        id="TryItOutButton"
        type="button"
        class="btn btn-primary"
        data-bs-toggle="tooltip"
        data-bs-title="Load example parameters/data for this workflow"
        @click="
          emit(`load-parameters`, {
            params: props.clowmInfo?.exampleParameters,
            metaParams: {},
          })
        "
      >
        Try it out
      </button>
      <button
        v-if="workflowId != undefined"
        type="button"
        class="btn btn-primary"
        data-bs-toggle="modal"
        data-bs-target="#last-parameterization-modal"
      >
        <font-awesome-icon icon="fas fa-user-gear" class="me-2" />
        My last parameterizations
      </button>
      <button
        class="btn btn-primary"
        data-bs-toggle="modal"
        data-bs-target="#parameterUploadModal"
      >
        <font-awesome-icon icon="fa-solid fa-upload" class="me-2" />
        Upload Parameters
      </button>
      <button type="submit" :form="formId" class="btn btn-success btn-lg">
        <font-awesome-icon icon="fa-solid fa-play" class="me-2" />
        Launch
      </button>
    </div>
  </div>
</template>

<style scoped></style>
